TagLib::DSDIFF::File Class Reference

An implementation of TagLib::File with DSDIFF specific methods. More...

`#include <dsdifffile.h>`

Inheritance diagram for TagLib::DSDIFF::File:
[legend]
Collaboration diagram for TagLib::DSDIFF::File:
[legend]

## Public Types

enum | TagTypes { NoTags = 0x0000 , DIIN = 0x0001 , ID3v2 = 0x0002 , AllTags = 0xffff }
Public Types inherited from TagLib::File
enum | Position { Beginning , Current , End }
enum | StripTags { StripNone , StripOthers }
enum | DuplicateTags { Duplicate , DoNotDuplicate }

## Public Member Functions

| File (FileName file, bool readProperties=true, Properties::ReadStyle propertiesStyle=Properties::Average, ID3v2::FrameFactory *frameFactory=nullptr)
| File (IOStream *stream, bool readProperties=true, Properties::ReadStyle propertiesStyle=Properties::Average, ID3v2::FrameFactory *frameFactory=nullptr)
| ~File () override
Tag * | tag () const override
ID3v2::Tag * | ID3v2Tag (bool create=false) const
DSDIFF::DIIN::Tag * | DIINTag (bool create=false) const
PropertyMap | properties () const override
void | removeUnsupportedProperties (const StringList &properties) override
PropertyMap | setProperties (const PropertyMap &) override
Properties * | audioProperties () const override
bool | save () override
bool | save (int tags, StripTags strip=StripOthers, ID3v2::Version version=ID3v2::v4)
void | strip (int tags=AllTags)
bool | hasID3v2Tag () const
bool | hasDIINTag () const
Public Member Functions inherited from TagLib::File
| File (const File &)=delete
File & | operator= (const File &)=delete
FileName | name () const
virtual StringList | complexPropertyKeys () const
virtual List< VariantMap > | complexProperties (const String &key) const
virtual bool | setComplexProperties (const String &key, const List< VariantMap > &value)
ByteVector | readBlock (size_t length)
void | writeBlock (const ByteVector &data)
offset_t | find (const ByteVector &pattern, offset_t fromOffset=0, const ByteVector &before=ByteVector())
offset_t | rfind (const ByteVector &pattern, offset_t fromOffset=0, const ByteVector &before=ByteVector())
void | insert (const ByteVector &data, offset_t start=0, size_t replace=0)
void | removeBlock (offset_t start=0, size_t length=0)
bool | readOnly () const
bool | isOpen () const
bool | isValid () const
void | seek (offset_t offset, Position p=Beginning)
void | clear ()
offset_t | tell () const
offset_t | length ()

## Static Public Member Functions

static bool | isSupported (IOStream *stream)

## Protected Types

enum | Endianness { BigEndian , LittleEndian }

## Additional Inherited Members

Protected Member Functions inherited from TagLib::File
| File (FileName fileName)
| File (IOStream *stream)
void | setValid (bool valid)
void | truncate (offset_t length)
Static Protected Member Functions inherited from TagLib::File
static unsigned int | bufferSize ()

## Detailed Description

An implementation of TagLib::File with DSDIFF specific methods.

This implements and provides an interface for DSDIFF files to the TagLib::Tag and TagLib::AudioProperties interfaces by way of implementing the abstract TagLib::File API as well as providing some additional information specific to DSDIFF files.

## Member Enumeration Documentation

## Endianness

enum TagLib::DSDIFF::File::Endianness

protected

Enumerator
BigEndian |
LittleEndian |

## TagTypes

enum TagLib::DSDIFF::File::TagTypes

This set of flags is used for various operations and is suitable for being OR-ed together.

Enumerator
NoTags | Empty set. Matches no tag types.
DIIN | Matches DIIN tags.
ID3v2 | Matches ID3v2 tags.
AllTags | Matches all tag types.

## Constructor & Destructor Documentation

## File() [1/2]

TagLib::DSDIFF::File::File | ( | FileName | file,
|  | bool | readProperties = true,
|  | Properties::ReadStyle | propertiesStyle = Properties::Average,
|  | ID3v2::FrameFactory * | frameFactory = nullptr )

Constructs a DSDIFF file from file. If readProperties is `true` the file's audio properties will also be read.

Note
  In the current implementation, propertiesStyle is ignored.

If this file contains an ID3v2 tag, the frames will be created using frameFactory (default if null).

References TagLib::AudioProperties::Average.

## File() [2/2]

TagLib::DSDIFF::File::File | ( | IOStream * | stream,
|  | bool | readProperties = true,
|  | Properties::ReadStyle | propertiesStyle = Properties::Average,
|  | ID3v2::FrameFactory * | frameFactory = nullptr )

Constructs a DSDIFF file from stream. If readProperties is `true` the file's audio properties will also be read.

If this file contains an ID3v2 tag, the frames will be created using frameFactory (default if null).

Note
  TagLib will not take ownership of the stream, the caller is responsible for deleting it after the File object.
  In the current implementation, propertiesStyle is ignored.

References TagLib::AudioProperties::Average.

## ~File()

TagLib::DSDIFF::File::~File | ( |  | ) |

override virtual

Destroys this instance of the File.

Reimplemented from TagLib::File.

## Member Function Documentation

## audioProperties()

Properties * TagLib::DSDIFF::File::audioProperties | ( |  | ) | const

override virtual

Returns the AIFF::Properties for this file. If no audio properties were read then this will return a null pointer.

Implements TagLib::File.

## DIINTag()

DSDIFF::DIIN::Tag * TagLib::DSDIFF::File::DIINTag | ( | bool | create = false | ) | const

Returns the DSDIFF DIIN Tag for this file

## hasDIINTag()

bool TagLib::DSDIFF::File::hasDIINTag | ( |  | ) | const

Returns whether or not the file on disk actually has the DSDIFF title and artist tags.

See also
  DIINTag()

## hasID3v2Tag()

bool TagLib::DSDIFF::File::hasID3v2Tag | ( |  | ) | const

Returns whether or not the file on disk actually has an ID3v2 tag.

See also
  ID3v2Tag()

## ID3v2Tag()

ID3v2::Tag * TagLib::DSDIFF::File::ID3v2Tag | ( | bool | create = false | ) | const

Returns the ID3V2 Tag for this file.

Note
  This always returns a valid pointer regardless of whether or not the file on disk has an ID3v2 tag. Use hasID3v2Tag() to check if the file on disk actually has an ID3v2 tag.

See also
  hasID3v2Tag()

## isSupported()

bool TagLib::DSDIFF::File::isSupported | ( | IOStream * | stream | ) |

static

Returns whether or not the given stream can be opened as a DSDIFF file.

Note
  This method is designed to do a quick check. The result may not necessarily be correct.

## properties()

PropertyMap TagLib::DSDIFF::File::properties | ( |  | ) | const

override virtual

Implements the unified property interface – export function. This method forwards to ID3v2::Tag::properties().

Reimplemented from TagLib::File.

Referenced by removeUnsupportedProperties().

## removeUnsupportedProperties()

void TagLib::DSDIFF::File::removeUnsupportedProperties | ( | const StringList & | properties | ) |

override virtual

Removes unsupported properties, or a subset of them, from the file's metadata. The parameter properties must contain only entries from properties().unsupportedData().

Reimplemented from TagLib::File.

References properties().

## save() [1/2]

bool TagLib::DSDIFF::File::save | ( |  | ) |

override virtual

Save the file. If at least one tag – ID3v1 or DIIN – exists this will duplicate its content into the other tag. This returns `true` if saving was successful.

If neither exists or if both tags are empty, this will strip the tags from the file.

This is the same as calling save(AllTags);

If you would like more granular control over the content of the tags, with the concession of generality, use parameterized save call below.

See also
  save(int tags)

Implements TagLib::File.

## save() [2/2]

bool TagLib::DSDIFF::File::save | ( | int | tags,
|  | StripTags | strip = StripOthers,
|  | ID3v2::Version | version = ID3v2::v4 )

Save the file. If strip is specified, it is possible to choose if tags not specified in tags should be stripped from the file or retained. With version, it is possible to specify whether ID3v2.4 or ID3v2.3 should be used.

References strip(), TagLib::File::StripOthers, and TagLib::ID3v2::v4.

## setProperties()

PropertyMap TagLib::DSDIFF::File::setProperties | ( | const PropertyMap & |  | ) |

override virtual

Implements the unified property interface – import function. This method forwards to ID3v2::Tag::setProperties().

Reimplemented from TagLib::File.

## strip()

void TagLib::DSDIFF::File::strip | ( | int | tags = AllTags | ) |

This will strip the tags that match the OR-ed together TagTypes from the file. By default it strips all tags. It returns `true` if the tags are successfully stripped.

Note
  This will update the file immediately.

References AllTags.

Referenced by save().

## tag()

Tag * TagLib::DSDIFF::File::tag | ( |  | ) | const

override virtual

Returns a pointer to a tag that is the union of the ID3v2 and DIIN tags. The ID3v2 tag is given priority in reading the information – if requested information exists in both the ID3v2 tag and the ID3v1 tag, the information from the ID3v2 tag will be returned.

If you would like more granular control over the content of the tags, with the concession of generality, use the tag-type specific calls.

Note
  As this tag is not implemented as an ID3v2 tag or a DIIN tag, but a union of the two this pointer may not be cast to the specific tag types.

See also
  ID3v2Tag()
  DIINTag()

Implements TagLib::File.

The documentation for this class was generated from the following file:

- dsdifffile.h